=== debian/changelog ===
julia (0.1.2+dfsg-3) unstable; urgency=low

  * Bump the B-D on dpkg-dev.
    Support for source:Package and source:Version fields was added in dpkg-dev
    1.16.2 (Closes: #706470)
  * Add support for DEB_BUILD_OPTIONS=nocheck (Closes: #706472)
  * Add julia-dbg package
  * Fix FTBFS with zlib >= 1.2.8 (Closes: #707962)
    - zlib-1.2.8.patch: new patch, fixes the gzip.jl test
    - tighten B-D on zlib1g-dev to >= 1:1.2.8

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 15 May 2013 12:44:14 +0200

julia (0.1.2+dfsg-2) unstable; urgency=low

  * Statically link against LLVM.
    With dynamic linking, strange bugs appear when the runtime library is not
    the same than the one used for building. At this stage it is not clear
    whether it is a Julia or LLVM bug. Reported as Julia issue #2494.
     - use-shared-llvm.patch: remove patch
     - add Built-Using field for julia binary package
     - keep a dependency of julia on libllvm3.2, since strpack.jl dlopen's it

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 03 Apr 2013 17:03:39 +0200

julia (0.1.2+dfsg-1) unstable; urgency=low

  * Imported Upstream version 0.1.2+dfsg.
    Contains hotfix for package manager.
  * debian/patches/fix-version.patch: new patch
  * Refresh other patches

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 07 Mar 2013 20:50:18 +0100

julia (0.1.1+dfsg-1) unstable; urgency=low

  * Imported Upstream version 0.1.1+dfsg
  * debian/copyright: reflect upstream changes
  * Refresh patches
  * Disable tk-wrapper, since it is no longer built upstream
  * Update README.debian

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 07 Mar 2013 12:14:59 +0100
